// ppm simple generation
// Simple c program , no opengl 
// ============================
#include <stdio.h>
#include <stdlib.h>

void GeneratePpmFile(
		char *cFilename,
		char *cPixelsOfCurrent,
		int iWidth,
		int iHeight,
		int iBytePerPixel=3)
{
	int i,j,k;
	FILE *fPpm;
	char *cPixelsForOutput;
	int iTotalPixelSize;
	iTotalPixelSize = iWidth*iHeight*iBytePerPixel;
	cPixelsForOutput = (char *)malloc(sizeof(char)*iTotalPixelSize);

	if(iBytePerPixel==3)
	{
		for(i=0; i<iWidth; i++)
		{
			for(j=0; j<iHeight; j++)
			{
				for(k=0; k<4; k++)
				{
					cPixelsForOutput[3*(i*iHeight + j) + 0] = cPixelsOfCurrent[3*(i*iHeight+j) + 0];
					cPixelsForOutput[3*(i*iHeight + j) + 1] = cPixelsOfCurrent[3*(i*iHeight+j) + 1];
					cPixelsForOutput[3*(i*iHeight + j) + 2] = cPixelsOfCurrent[3*(i*iHeight+j) + 2];
				}
			}
		}	
	}
	else if(iBytePerPixel==4)
	{
		for(i=0; i<iWidth; i++)
		{
			for(j=0; j<iHeight; j++)
			{
				for( k=0; k<4; k++)
				{
					cPixelsForOutput[3*(i*iHeight + j) + 0] = cPixelsOfCurrent[4*(i*iHeight + j) + 0];
					cPixelsForOutput[3*(i*iHeight + j) + 1] = cPixelsOfCurrent[4*(i*iHeight + j) + 1];
					cPixelsForOutput[3*(i*iHeight + j) + 2] = cPixelsOfCurrent[4*(i*iHeight + j) + 2];
				}
			}
		}
	}
	else
	{
		fprintf(stderr, "error: un-supported format.\n");
		fprintf(stderr, "error: %d,%d,%d \n", iWidth, iHeight, iBytePerPixel);
		return;
	}
	
	fPpm = fopen(cFilename, "w");
	{
		fprintf(fPpm, "P6\n");
		fprintf(fPpm, "%d %d\n", iWidth, iHeight);
	}
	fclose(fPpm);
	fPpm = fopen(cFilename, "ab");
	{
		fputc(50, fPpm);
		fputc(53, fPpm);
		fputc(53, fPpm);
		fputc(10, fPpm);
		
		for(j=0; j<iHeight; j++)
		{
			for(i=0; i<iWidth; i++)
			{
				for(k=0; k<3; k++)
				{
					fputc(cPixelsForOutput[(iHeight - 1 - j)*iWidth*3 + 3*i + k], fPpm);
				}
			}
		}
	}
	fclose(fPpm);
	return;
}

int main(int argc, char **argv)
{
	int iPpmWidth			= 256;
	int iPpmHeight			= 256;
	int iPpmBytePerPixel	= 3;
	int iPpmTotalPixelSize	= iPpmWidth*iPpmHeight*iPpmBytePerPixel;
	char *cPpmTexels;
	char cPpmFilename[256]	= "kg.ppm";

	cPpmTexels = (char *)malloc(sizeof(char)*iPpmTotalPixelSize);
	for(int i=0; i<iPpmWidth; i++)
	{
		for(int j=0; j<iPpmHeight; j++)
		{
			cPpmTexels[iPpmBytePerPixel*(j*iPpmWidth + i) + 0] = i;
			cPpmTexels[iPpmBytePerPixel*(j*iPpmWidth + i) + 1] = j;
			cPpmTexels[iPpmBytePerPixel*(j*iPpmWidth + i) + 2] = 0x0;
		 }
	}
	GeneratePpmFile(cPpmFilename, cPpmTexels, iPpmWidth, iPpmHeight, iPpmBytePerPixel);

	return 0;
}
